// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/dataproc/v1/autoscaling_policies.proto

#include "google/cloud/dataproc/autoscaling_policy_connection_idempotency_policy.h"
#include "absl/memory/memory.h"
#include <memory>

namespace google {
namespace cloud {
namespace dataproc {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

AutoscalingPolicyServiceConnectionIdempotencyPolicy::
    ~AutoscalingPolicyServiceConnectionIdempotencyPolicy() = default;

namespace {
class DefaultAutoscalingPolicyServiceConnectionIdempotencyPolicy
    : public AutoscalingPolicyServiceConnectionIdempotencyPolicy {
 public:
  ~DefaultAutoscalingPolicyServiceConnectionIdempotencyPolicy() override =
      default;

  /// Create a new copy of this object.
  std::unique_ptr<AutoscalingPolicyServiceConnectionIdempotencyPolicy> clone()
      const override {
    return absl::make_unique<
        DefaultAutoscalingPolicyServiceConnectionIdempotencyPolicy>(*this);
  }

  Idempotency CreateAutoscalingPolicy(
      google::cloud::dataproc::v1::CreateAutoscalingPolicyRequest const&)
      override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency UpdateAutoscalingPolicy(
      google::cloud::dataproc::v1::UpdateAutoscalingPolicyRequest const&)
      override {
    return Idempotency::kIdempotent;
  }

  Idempotency GetAutoscalingPolicy(
      google::cloud::dataproc::v1::GetAutoscalingPolicyRequest const&)
      override {
    return Idempotency::kIdempotent;
  }

  Idempotency ListAutoscalingPolicies(
      google::cloud::dataproc::v1::ListAutoscalingPoliciesRequest) override {
    return Idempotency::kIdempotent;
  }

  Idempotency DeleteAutoscalingPolicy(
      google::cloud::dataproc::v1::DeleteAutoscalingPolicyRequest const&)
      override {
    return Idempotency::kNonIdempotent;
  }
};
}  // namespace

std::unique_ptr<AutoscalingPolicyServiceConnectionIdempotencyPolicy>
MakeDefaultAutoscalingPolicyServiceConnectionIdempotencyPolicy() {
  return absl::make_unique<
      DefaultAutoscalingPolicyServiceConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace dataproc
}  // namespace cloud
}  // namespace google
