// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/dataproc/v1/clusters.proto

#include "google/cloud/dataproc/cluster_controller_connection_idempotency_policy.h"
#include "absl/memory/memory.h"
#include <memory>

namespace google {
namespace cloud {
namespace dataproc {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

ClusterControllerConnectionIdempotencyPolicy::
    ~ClusterControllerConnectionIdempotencyPolicy() = default;

namespace {
class DefaultClusterControllerConnectionIdempotencyPolicy
    : public ClusterControllerConnectionIdempotencyPolicy {
 public:
  ~DefaultClusterControllerConnectionIdempotencyPolicy() override = default;

  /// Create a new copy of this object.
  std::unique_ptr<ClusterControllerConnectionIdempotencyPolicy> clone()
      const override {
    return absl::make_unique<
        DefaultClusterControllerConnectionIdempotencyPolicy>(*this);
  }

  Idempotency CreateCluster(
      google::cloud::dataproc::v1::CreateClusterRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency UpdateCluster(
      google::cloud::dataproc::v1::UpdateClusterRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency StopCluster(
      google::cloud::dataproc::v1::StopClusterRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency StartCluster(
      google::cloud::dataproc::v1::StartClusterRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency DeleteCluster(
      google::cloud::dataproc::v1::DeleteClusterRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency GetCluster(
      google::cloud::dataproc::v1::GetClusterRequest const&) override {
    return Idempotency::kIdempotent;
  }

  Idempotency ListClusters(
      google::cloud::dataproc::v1::ListClustersRequest) override {
    return Idempotency::kIdempotent;
  }

  Idempotency DiagnoseCluster(
      google::cloud::dataproc::v1::DiagnoseClusterRequest const&) override {
    return Idempotency::kNonIdempotent;
  }
};
}  // namespace

std::unique_ptr<ClusterControllerConnectionIdempotencyPolicy>
MakeDefaultClusterControllerConnectionIdempotencyPolicy() {
  return absl::make_unique<
      DefaultClusterControllerConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace dataproc
}  // namespace cloud
}  // namespace google
