// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/dataproc/v1/jobs.proto

#include "google/cloud/dataproc/job_controller_connection_idempotency_policy.h"
#include "absl/memory/memory.h"
#include <memory>

namespace google {
namespace cloud {
namespace dataproc {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

JobControllerConnectionIdempotencyPolicy::
    ~JobControllerConnectionIdempotencyPolicy() = default;

namespace {
class DefaultJobControllerConnectionIdempotencyPolicy
    : public JobControllerConnectionIdempotencyPolicy {
 public:
  ~DefaultJobControllerConnectionIdempotencyPolicy() override = default;

  /// Create a new copy of this object.
  std::unique_ptr<JobControllerConnectionIdempotencyPolicy> clone()
      const override {
    return absl::make_unique<DefaultJobControllerConnectionIdempotencyPolicy>(
        *this);
  }

  Idempotency SubmitJob(
      google::cloud::dataproc::v1::SubmitJobRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency SubmitJobAsOperation(
      google::cloud::dataproc::v1::SubmitJobRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency GetJob(
      google::cloud::dataproc::v1::GetJobRequest const&) override {
    return Idempotency::kIdempotent;
  }

  Idempotency ListJobs(google::cloud::dataproc::v1::ListJobsRequest) override {
    return Idempotency::kIdempotent;
  }

  Idempotency UpdateJob(
      google::cloud::dataproc::v1::UpdateJobRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency CancelJob(
      google::cloud::dataproc::v1::CancelJobRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency DeleteJob(
      google::cloud::dataproc::v1::DeleteJobRequest const&) override {
    return Idempotency::kNonIdempotent;
  }
};
}  // namespace

std::unique_ptr<JobControllerConnectionIdempotencyPolicy>
MakeDefaultJobControllerConnectionIdempotencyPolicy() {
  return absl::make_unique<DefaultJobControllerConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace dataproc
}  // namespace cloud
}  // namespace google
