// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/dialogflow/cx/v3/page.proto

#include "google/cloud/dialogflow_cx/pages_connection_idempotency_policy.h"
#include "absl/memory/memory.h"
#include <memory>

namespace google {
namespace cloud {
namespace dialogflow_cx {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

PagesConnectionIdempotencyPolicy::~PagesConnectionIdempotencyPolicy() = default;

namespace {
class DefaultPagesConnectionIdempotencyPolicy
    : public PagesConnectionIdempotencyPolicy {
 public:
  ~DefaultPagesConnectionIdempotencyPolicy() override = default;

  /// Create a new copy of this object.
  std::unique_ptr<PagesConnectionIdempotencyPolicy> clone() const override {
    return absl::make_unique<DefaultPagesConnectionIdempotencyPolicy>(*this);
  }

  Idempotency ListPages(
      google::cloud::dialogflow::cx::v3::ListPagesRequest) override {
    return Idempotency::kIdempotent;
  }

  Idempotency GetPage(
      google::cloud::dialogflow::cx::v3::GetPageRequest const&) override {
    return Idempotency::kIdempotent;
  }

  Idempotency CreatePage(
      google::cloud::dialogflow::cx::v3::CreatePageRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency UpdatePage(
      google::cloud::dialogflow::cx::v3::UpdatePageRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency DeletePage(
      google::cloud::dialogflow::cx::v3::DeletePageRequest const&) override {
    return Idempotency::kNonIdempotent;
  }
};
}  // namespace

std::unique_ptr<PagesConnectionIdempotencyPolicy>
MakeDefaultPagesConnectionIdempotencyPolicy() {
  return absl::make_unique<DefaultPagesConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace dialogflow_cx
}  // namespace cloud
}  // namespace google
