// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/dialogflow/cx/v3/transition_route_group.proto

#include "google/cloud/dialogflow_cx/transition_route_groups_connection_idempotency_policy.h"
#include "absl/memory/memory.h"
#include <memory>

namespace google {
namespace cloud {
namespace dialogflow_cx {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

TransitionRouteGroupsConnectionIdempotencyPolicy::
    ~TransitionRouteGroupsConnectionIdempotencyPolicy() = default;

namespace {
class DefaultTransitionRouteGroupsConnectionIdempotencyPolicy
    : public TransitionRouteGroupsConnectionIdempotencyPolicy {
 public:
  ~DefaultTransitionRouteGroupsConnectionIdempotencyPolicy() override = default;

  /// Create a new copy of this object.
  std::unique_ptr<TransitionRouteGroupsConnectionIdempotencyPolicy> clone()
      const override {
    return absl::make_unique<
        DefaultTransitionRouteGroupsConnectionIdempotencyPolicy>(*this);
  }

  Idempotency ListTransitionRouteGroups(
      google::cloud::dialogflow::cx::v3::ListTransitionRouteGroupsRequest)
      override {
    return Idempotency::kIdempotent;
  }

  Idempotency GetTransitionRouteGroup(
      google::cloud::dialogflow::cx::v3::GetTransitionRouteGroupRequest const&)
      override {
    return Idempotency::kIdempotent;
  }

  Idempotency CreateTransitionRouteGroup(
      google::cloud::dialogflow::cx::v3::
          CreateTransitionRouteGroupRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency UpdateTransitionRouteGroup(
      google::cloud::dialogflow::cx::v3::
          UpdateTransitionRouteGroupRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency DeleteTransitionRouteGroup(
      google::cloud::dialogflow::cx::v3::
          DeleteTransitionRouteGroupRequest const&) override {
    return Idempotency::kNonIdempotent;
  }
};
}  // namespace

std::unique_ptr<TransitionRouteGroupsConnectionIdempotencyPolicy>
MakeDefaultTransitionRouteGroupsConnectionIdempotencyPolicy() {
  return absl::make_unique<
      DefaultTransitionRouteGroupsConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace dialogflow_cx
}  // namespace cloud
}  // namespace google
