// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/dialogflow/v2/context.proto

#include "google/cloud/dialogflow_es/contexts_connection_idempotency_policy.h"
#include "absl/memory/memory.h"
#include <memory>

namespace google {
namespace cloud {
namespace dialogflow_es {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

ContextsConnectionIdempotencyPolicy::~ContextsConnectionIdempotencyPolicy() =
    default;

namespace {
class DefaultContextsConnectionIdempotencyPolicy
    : public ContextsConnectionIdempotencyPolicy {
 public:
  ~DefaultContextsConnectionIdempotencyPolicy() override = default;

  /// Create a new copy of this object.
  std::unique_ptr<ContextsConnectionIdempotencyPolicy> clone() const override {
    return absl::make_unique<DefaultContextsConnectionIdempotencyPolicy>(*this);
  }

  Idempotency ListContexts(
      google::cloud::dialogflow::v2::ListContextsRequest) override {
    return Idempotency::kIdempotent;
  }

  Idempotency GetContext(
      google::cloud::dialogflow::v2::GetContextRequest const&) override {
    return Idempotency::kIdempotent;
  }

  Idempotency CreateContext(
      google::cloud::dialogflow::v2::CreateContextRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency UpdateContext(
      google::cloud::dialogflow::v2::UpdateContextRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency DeleteContext(
      google::cloud::dialogflow::v2::DeleteContextRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency DeleteAllContexts(
      google::cloud::dialogflow::v2::DeleteAllContextsRequest const&) override {
    return Idempotency::kNonIdempotent;
  }
};
}  // namespace

std::unique_ptr<ContextsConnectionIdempotencyPolicy>
MakeDefaultContextsConnectionIdempotencyPolicy() {
  return absl::make_unique<DefaultContextsConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace dialogflow_es
}  // namespace cloud
}  // namespace google
