// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/dialogflow/v2/conversation_model.proto

#include "google/cloud/dialogflow_es/conversation_models_connection_idempotency_policy.h"
#include "absl/memory/memory.h"
#include <memory>

namespace google {
namespace cloud {
namespace dialogflow_es {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

ConversationModelsConnectionIdempotencyPolicy::
    ~ConversationModelsConnectionIdempotencyPolicy() = default;

namespace {
class DefaultConversationModelsConnectionIdempotencyPolicy
    : public ConversationModelsConnectionIdempotencyPolicy {
 public:
  ~DefaultConversationModelsConnectionIdempotencyPolicy() override = default;

  /// Create a new copy of this object.
  std::unique_ptr<ConversationModelsConnectionIdempotencyPolicy> clone()
      const override {
    return absl::make_unique<
        DefaultConversationModelsConnectionIdempotencyPolicy>(*this);
  }

  Idempotency CreateConversationModel(
      google::cloud::dialogflow::v2::CreateConversationModelRequest const&)
      override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency GetConversationModel(
      google::cloud::dialogflow::v2::GetConversationModelRequest const&)
      override {
    return Idempotency::kIdempotent;
  }

  Idempotency ListConversationModels(
      google::cloud::dialogflow::v2::ListConversationModelsRequest) override {
    return Idempotency::kIdempotent;
  }

  Idempotency DeleteConversationModel(
      google::cloud::dialogflow::v2::DeleteConversationModelRequest const&)
      override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency DeployConversationModel(
      google::cloud::dialogflow::v2::DeployConversationModelRequest const&)
      override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency UndeployConversationModel(
      google::cloud::dialogflow::v2::UndeployConversationModelRequest const&)
      override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency GetConversationModelEvaluation(
      google::cloud::dialogflow::v2::
          GetConversationModelEvaluationRequest const&) override {
    return Idempotency::kIdempotent;
  }

  Idempotency ListConversationModelEvaluations(
      google::cloud::dialogflow::v2::ListConversationModelEvaluationsRequest)
      override {
    return Idempotency::kIdempotent;
  }

  Idempotency CreateConversationModelEvaluation(
      google::cloud::dialogflow::v2::
          CreateConversationModelEvaluationRequest const&) override {
    return Idempotency::kNonIdempotent;
  }
};
}  // namespace

std::unique_ptr<ConversationModelsConnectionIdempotencyPolicy>
MakeDefaultConversationModelsConnectionIdempotencyPolicy() {
  return absl::make_unique<
      DefaultConversationModelsConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace dialogflow_es
}  // namespace cloud
}  // namespace google
