// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/dialogflow/v2/participant.proto

#include "google/cloud/dialogflow_es/participants_connection_idempotency_policy.h"
#include "absl/memory/memory.h"
#include <memory>

namespace google {
namespace cloud {
namespace dialogflow_es {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

ParticipantsConnectionIdempotencyPolicy::
    ~ParticipantsConnectionIdempotencyPolicy() = default;

namespace {
class DefaultParticipantsConnectionIdempotencyPolicy
    : public ParticipantsConnectionIdempotencyPolicy {
 public:
  ~DefaultParticipantsConnectionIdempotencyPolicy() override = default;

  /// Create a new copy of this object.
  std::unique_ptr<ParticipantsConnectionIdempotencyPolicy> clone()
      const override {
    return absl::make_unique<DefaultParticipantsConnectionIdempotencyPolicy>(
        *this);
  }

  Idempotency CreateParticipant(
      google::cloud::dialogflow::v2::CreateParticipantRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency GetParticipant(
      google::cloud::dialogflow::v2::GetParticipantRequest const&) override {
    return Idempotency::kIdempotent;
  }

  Idempotency ListParticipants(
      google::cloud::dialogflow::v2::ListParticipantsRequest) override {
    return Idempotency::kIdempotent;
  }

  Idempotency UpdateParticipant(
      google::cloud::dialogflow::v2::UpdateParticipantRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency AnalyzeContent(
      google::cloud::dialogflow::v2::AnalyzeContentRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency SuggestArticles(
      google::cloud::dialogflow::v2::SuggestArticlesRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency SuggestFaqAnswers(
      google::cloud::dialogflow::v2::SuggestFaqAnswersRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency SuggestSmartReplies(
      google::cloud::dialogflow::v2::SuggestSmartRepliesRequest const&)
      override {
    return Idempotency::kNonIdempotent;
  }
};
}  // namespace

std::unique_ptr<ParticipantsConnectionIdempotencyPolicy>
MakeDefaultParticipantsConnectionIdempotencyPolicy() {
  return absl::make_unique<DefaultParticipantsConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace dialogflow_es
}  // namespace cloud
}  // namespace google
